000100 IDENTIFICATION DIVISION.                                         POS00109
000200 PROGRAM-ID.    BITPK.                                            96/12/06
000300                                                                  96/12/06
000400 AUTHOR.        LEIF SVALGAARD.                                   96/12/06
000500 DATE-WRITTEN.  96/12/06                                          96/12/06
000600     -REVISED:  97/01/22.                                         97/01/22
000700                                                                  96/12/06
000800 ENVIRONMENT DIVISION.                                            96/12/06
000900                                                                  96/12/06
001000 CONFIGURATION SECTION.                                           96/12/06
001100 SOURCE-COMPUTER. PORTABLE.                                       96/12/06
001200 OBJECT-COMPUTER. PORTABLE.                                       96/12/06
001300                                                                  96/12/06
001400 DATA DIVISION.                                                   96/12/06
001500                                                                  96/12/06
001600 WORKING-STORAGE SECTION.                                         96/12/06
001700                                                                  96/12/06
001800 01  BIT-HANDLING.                                                96/12/06
001900     02  BIT-VALUE               PIC 9(10)  COMP.                 96/12/07
002000     02  BIT-TOP                 PIC 9(10)  COMP  VALUE ZEROES.   96/12/07
002100     02  THE-WEIGHT              PIC 9(10)  COMP.                 96/12/07
002200     02  BIT-WEIGHTS.                                             96/12/07
002300         03  BIT-WEIGHT          PIC 9(10)  COMP  OCCURS 32 TIMES.96/12/07
002400                                                                  96/12/07
002500     02  BIT-COUNT               PIC S9(3)  COMP.                 96/12/06
002600     02  BIT-MATCH               PIC S9(3)  COMP.                 96/12/06
002700     02  BIT-NBR                 PIC S9(3)  COMP.                 96/12/06
002800                                                                  96/12/07
002900     02  BIT-WANTED              PIC X.                           96/12/07
003000     02  BIT-STRING.                                              96/12/06
003100         03  THE-BIT             PIC X      OCCURS 32 TIMES.      96/12/06
003200                                                                  96/12/06
003300 LINKAGE SECTION.                                                 96/12/06
003400                                                                  96/12/06
003500 01  BITPK-CONTROL.                                               96/12/06
003600     02  SESSION-TASK-ID         PIC X(4).                        96/12/06
003700     02  BITPK-OPERATION         PIC X(1).                        96/12/06
003800     02  BITPK-FEEDBACK          PIC X(1).                        96/12/06
003900                                                                  96/12/06
004000     02  BITPK-PATTERN           PIC 9(10)  COMP.                 96/12/07
004100     02  BITPK-BITS.                                              96/12/06
004200         03  BITPK-BIT           PIC X      OCCURS 32 TIMES.      96/12/06
004300                                                                  96/12/06
004400 PROCEDURE DIVISION                                               96/12/06
004500     USING BITPK-CONTROL.                                         96/12/06
004600 BEGIN-PROGRAM.                                                   96/12/06
004700     IF BIT-TOP = ZEROES                                          96/12/07
004800         PERFORM INITIALIZE-BIT-WEIGHTS                           96/12/07
004900     .                                                            96/12/07
005000     PERFORM GET-AND-CHECK-THE-BITS                               97/01/19
005100     MOVE SPACE TO BITPK-FEEDBACK                                 96/12/06
005200     IF BITPK-OPERATION = "G"                                     96/12/06
005300         MOVE BIT-STRING TO BITPK-BITS                            96/12/06
005400     ELSE                                                         96/12/06
005500     IF BITPK-OPERATION = "S" OR "O"                              97/01/19
005600         PERFORM SET-THE-BITS                                     96/12/07
005700     ELSE                                                         96/12/07
005800     IF BITPK-OPERATION = "C"                                     96/12/07
005900         PERFORM CLEAR-THE-BITS                                   96/12/07
006000     ELSE                                                         96/12/07
006100     IF BITPK-OPERATION = "A"                                     97/01/19
006200         PERFORM AND-THE-BITS                                     97/01/19
006300     ELSE                                                         97/01/19
006400     IF BITPK-OPERATION = "X"                                     97/01/19
006500         PERFORM XOR-THE-BITS                                     97/01/19
006600     ELSE                                                         97/01/19
006700     IF BITPK-OPERATION = "1"                                     96/12/07
006800         PERFORM TEST-IF-ONES                                     96/12/07
006900     ELSE                                                         96/12/07
007000     IF BITPK-OPERATION = "0"                                     96/12/07
007100         PERFORM TEST-IF-ZEROES                                   96/12/07
007200     ELSE                                                         96/12/07
007300     IF BITPK-OPERATION = "P"                                     96/12/07
007400         PERFORM PACK-THE-BITS                                    96/12/07
007500     ELSE                                                         96/12/07
007600         MOVE "OPERR" TO BITPK-FEEDBACK                           96/12/07
007700     .                                                            96/12/07
007800 RETURN-TO-CALLER.                                                96/12/06
007900     EXIT PROGRAM                                                 96/12/06
008000     .                                                            96/12/06
008100                                                                  96/12/06
008200 INITIALIZE-BIT-WEIGHTS.                                          96/12/07
008300     MOVE 1 TO THE-WEIGHT                                         96/12/07
008400     PERFORM SET-BIT-WEIGHT                                       96/12/07
008500       VARYING BIT-NBR FROM 32 BY -1                              96/12/07
008600         UNTIL BIT-NBR < 1                                        96/12/07
008700                                                                  96/12/07
008800     MOVE THE-WEIGHT TO BIT-TOP                                   96/12/07
008900     .                                                            96/12/07
009000                                                                  96/12/07
009100 SET-BIT-WEIGHT.                                                  96/12/07
009200     MOVE THE-WEIGHT TO BIT-WEIGHT (BIT-NBR)                      96/12/07
009300     ADD  THE-WEIGHT TO THE-WEIGHT                                96/12/07
009400     .                                                            96/12/07
009500                                                                  96/12/07
009600 GET-AND-CHECK-THE-BITS.                                          97/01/19
009700     MOVE BITPK-PATTERN TO BIT-VALUE                              96/12/06
009800     IF BIT-VALUE < BIT-TOP                                       96/12/07
009900         MOVE ZEROES TO BIT-STRING                                97/01/22
010000         PERFORM GET-THE-BIT                                      96/12/06
010100           VARYING BIT-NBR FROM 1 BY 1                            96/12/06
010200             UNTIL BIT-NBR > 32                                   96/12/06
010300                                                                  97/01/19
010400         PERFORM CHECK-THE-BIT                                    97/01/19
010500           VARYING BIT-NBR FROM 1 BY 1                            97/01/19
010600             UNTIL BIT-NBR > 32                                   97/01/19
010700     ELSE                                                         96/12/06
010800         MOVE "RANGE" TO BITPK-FEEDBACK                           96/12/06
010900         MOVE  ZEROES TO BIT-STRING                               96/12/06
011000     .                                                            96/12/06
011100                                                                  96/12/06
011200 GET-THE-BIT.                                                     96/12/06
011300     IF BIT-VALUE NOT < BIT-WEIGHT (BIT-NBR)                      97/01/22
011400         SUBTRACT BIT-WEIGHT (BIT-NBR) FROM BIT-VALUE             96/12/07
011500         MOVE "1" TO THE-BIT (BIT-NBR)                            96/12/06
011600     .                                                            96/12/06
011700                                                                  96/12/06
011800 CHECK-THE-BIT.                                                   97/01/19
011900     IF BITPK-BIT (BIT-NBR) = ZERO                                97/01/22
012000         NEXT SENTENCE                                            97/01/22
012100     ELSE                                                         97/01/19
012200     IF BITPK-BIT (BIT-NBR) = SPACE                               97/01/22
012300         MOVE ZERO TO BITPK-BIT (BIT-NBR)                         97/01/22
012400     ELSE                                                         97/01/22
012500     IF BITPK-BIT (BIT-NBR) NOT = "1"                             97/01/19
012600         MOVE "1"  TO BITPK-BIT (BIT-NBR)                         97/01/19
012700     .                                                            97/01/19
012800                                                                  97/01/19
012900 SET-THE-BITS.                                                    96/12/06
013000     IF BITPK-FEEDBACK = SPACE                                    96/12/07
013100         PERFORM SET-THE-BIT                                      96/12/07
013200           VARYING BIT-NBR FROM 1 BY 1                            96/12/07
013300             UNTIL BIT-NBR > 32                                   96/12/07
013400     .                                                            96/12/06
013500                                                                  96/12/06
013600 SET-THE-BIT.                                                     96/12/06
013700     IF BITPK-BIT (BIT-NBR) = "1"                                 96/12/07
013800         IF THE-BIT (BIT-NBR) = "0"                               96/12/06
013900             MOVE "1" TO THE-BIT (BIT-NBR)                        96/12/06
014000             ADD BIT-WEIGHT (BIT-NBR) TO BITPK-PATTERN            96/12/07
014100     .                                                            96/12/06
014200                                                                  96/12/06
014300 CLEAR-THE-BITS.                                                  96/12/06
014400     IF BITPK-FEEDBACK = SPACE                                    96/12/07
014500         PERFORM CLEAR-THE-BIT                                    96/12/07
014600           VARYING BIT-NBR FROM 1 BY 1                            96/12/07
014700             UNTIL BIT-NBR > 32                                   96/12/07
014800     .                                                            96/12/06
014900                                                                  96/12/06
015000 CLEAR-THE-BIT.                                                   96/12/06
015100     IF BITPK-BIT (BIT-NBR) = "1"                                 96/12/07
015200         IF THE-BIT (BIT-NBR) = "1"                               96/12/06
015300             MOVE "0" TO THE-BIT (BIT-NBR)                        96/12/06
015400             SUBTRACT BIT-WEIGHT (BIT-NBR) FROM BITPK-PATTERN     96/12/07
015500     .                                                            96/12/06
015600                                                                  96/12/06
015700 AND-THE-BITS.                                                    97/01/19
015800     IF BITPK-FEEDBACK = SPACE                                    97/01/19
015900         PERFORM AND-THE-BIT                                      97/01/19
016000           VARYING BIT-NBR FROM 1 BY 1                            97/01/19
016100             UNTIL BIT-NBR > 32                                   97/01/19
016200     .                                                            97/01/19
016300                                                                  97/01/19
016400 AND-THE-BIT.                                                     97/01/19
016500     IF THE-BIT (BIT-NBR) = "1"                                   97/01/19
016600         IF BITPK-BIT (BIT-NBR) NOT = "1"                         97/01/19
016700             MOVE "0" TO THE-BIT (BIT-NBR)                        97/01/19
016800             SUBTRACT BIT-WEIGHT (BIT-NBR) FROM BITPK-PATTERN     97/01/19
016900     .                                                            97/01/19
017000                                                                  97/01/19
017100 XOR-THE-BITS.                                                    97/01/19
017200     IF BITPK-FEEDBACK = SPACE                                    97/01/19
017300         PERFORM XOR-THE-BIT                                      97/01/19
017400           VARYING BIT-NBR FROM 1 BY 1                            97/01/19
017500             UNTIL BIT-NBR > 32                                   97/01/19
017600     .                                                            97/01/19
017700                                                                  97/01/19
017800 XOR-THE-BIT.                                                     97/01/19
017900     IF BITPK-BIT (BIT-NBR) = THE-BIT (BIT-NBR)                   97/01/19
018000         IF THE-BIT (BIT-NBR) = "1"                               97/01/19
018100             MOVE "0" TO THE-BIT (BIT-NBR)                        97/01/19
018200             SUBTRACT BIT-WEIGHT (BIT-NBR) FROM BITPK-PATTERN     97/01/19
018300         ELSE                                                     97/01/19
018400             NEXT SENTENCE                                        97/01/19
018500     ELSE                                                         97/01/19
018600         IF THE-BIT (BIT-NBR) = "0"                               97/01/19
018700             MOVE "1" TO THE-BIT (BIT-NBR)                        97/01/19
018800             ADD      BIT-WEIGHT (BIT-NBR)  TO  BITPK-PATTERN     97/01/19
018900         ELSE                                                     97/01/19
019000             NEXT SENTENCE                                        97/01/19
019100     .                                                            97/01/19
019200                                                                  97/01/19
019300 TEST-IF-ONES.                                                    96/12/06
019400     IF BITPK-FEEDBACK = SPACE                                    96/12/07
019500         MOVE "1" TO BIT-WANTED                                   96/12/07
019600         PERFORM TEST-THE-BITS                                    96/12/07
019700     .                                                            96/12/07
019800                                                                  96/12/07
019900 TEST-THE-BITS.                                                   96/12/07
020000     MOVE ZEROES TO BIT-COUNT, BIT-MATCH                          96/12/06
020100     PERFORM TEST-IF-BIT-IS-WANTED                                96/12/07
020200       VARYING BIT-NBR FROM 1 BY 1                                96/12/06
020300         UNTIL BIT-NBR > 32                                       96/12/06
020400                                                                  96/12/06
020500     IF BIT-COUNT = BIT-MATCH                                     96/12/07
020600         MOVE "ALL"  TO BITPK-FEEDBACK                            96/12/07
020700     ELSE                                                         96/12/07
020800     IF BIT-MATCH = ZEROES                                        96/12/07
020900         MOVE "NONE" TO BITPK-FEEDBACK                            96/12/07
021000     ELSE                                                         96/12/07
021100         MOVE "SOME" TO BITPK-FEEDBACK                            96/12/07
021200     .                                                            96/12/06
021300                                                                  96/12/06
021400 TEST-IF-BIT-IS-WANTED.                                           96/12/07
021500     IF BITPK-BIT (BIT-NBR) = "1"                                 96/12/07
021600         ADD 1 TO BIT-COUNT                                       96/12/06
021700         IF THE-BIT (BIT-NBR) = BIT-WANTED                        96/12/07
021800             ADD 1 TO BIT-MATCH                                   96/12/06
021900     .                                                            96/12/06
022000                                                                  96/12/07
022100 TEST-IF-ZEROES.                                                  96/12/07
022200     IF BITPK-FEEDBACK = SPACE                                    96/12/07
022300         MOVE "0" TO BIT-WANTED                                   96/12/07
022400         PERFORM TEST-THE-BITS                                    96/12/07
022500     .                                                            96/12/07
022600                                                                  96/12/07
022700 PACK-THE-BITS.                                                   96/12/07
022800     MOVE ZEROES TO BITPK-PATTERN                                 96/12/07
022900     PERFORM PACK-THE-BIT                                         96/12/07
023000       VARYING BIT-NBR FROM 1 BY 1                                96/12/07
023100         UNTIL BIT-NBR > 32                                       96/12/07
023200     .                                                            96/12/07
023300                                                                  96/12/07
023400 PACK-THE-BIT.                                                    96/12/07
023500     IF BITPK-BIT (BIT-NBR) = "1"                                 96/12/07
023600         ADD BIT-WEIGHT (BIT-NBR) TO BITPK-PATTERN                96/12/07
023700     .                                                            96/12/07